/* 
===============================================================================
=== Released under GPL (GNU Public License) ==== No Any Warranty ==============
=============================================================================== 
*/ 
 
#include "../include/common.h"  
#include "../include/dialogs.h" 

void OzEDIT_AboutDialog();
void OzEDIT_ErrorDialog(char *,void *);
void OzEDIT_InfoDialog(char *,void *);
gint OzEDIT_AreYouSureDialog(char *,void *);

/* == OzEDIT_AreYouSureDialog() ==================================================== */
gint OzEDIT_AreYouSureDialog(char *v_message,void *v_args) {
    GtkWidget *areyousure_dialog;
    gint response;
    areyousure_dialog = gtk_message_dialog_new(NULL,GTK_DIALOG_DESTROY_WITH_PARENT,GTK_MESSAGE_QUESTION,GTK_BUTTONS_YES_NO,v_message,v_args);
    response = gtk_dialog_run(GTK_DIALOG(areyousure_dialog));
    gtk_widget_destroy(areyousure_dialog);
    return response;
}


/* == OzEDIT_AboutDialog() ==================================================== */
void OzEDIT_AboutDialog() {
    GtkWidget *about_dialog,*logo_image,*about_table,*about_label;
    GdkPixmap *logo_pixmap;
    GdkBitmap *logo_mask;
    GtkStyle *logo_style;
    gchar text[80];
    
    about_dialog = gtk_dialog_new_with_buttons ("About OzEDITor",NULL,
                                                  GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
                                                  GTK_STOCK_OK,
                                                  GTK_RESPONSE_ACCEPT,
                                                  NULL);
    gtk_window_set_title(GTK_WINDOW(about_dialog),"About OzEDITor...");
    gtk_widget_realize(about_dialog);
    gtk_container_set_border_width(GTK_CONTAINER(about_dialog), 1);

    about_table = gtk_table_new(2,1,FALSE);
    gtk_container_add(GTK_CONTAINER(GTK_DIALOG(about_dialog)->vbox),about_table);

    logo_style = gtk_widget_get_style(about_dialog);
    logo_pixmap = gdk_pixmap_create_from_xpm_d(about_dialog->window,&logo_mask,&logo_style->bg[GTK_STATE_NORMAL],(gchar **)logo_xpm);
    logo_image = gtk_image_new_from_pixmap(logo_pixmap, logo_mask);
    gtk_table_attach_defaults(GTK_TABLE(about_table),logo_image,0,1,0,1);	
    gtk_widget_show(logo_image);

#ifdef OZEDIT_PRERELEASE
    g_snprintf(text,80,"PRERELEASE of Version %d.%d.%d - Release date %s - CHECK FOR FINAL !\n",OZEDIT_VERSION,OZEDIT_SUBVERSION,OZEDIT_PATCH,OZEDIT_RELEASE_DATE);
#else
    g_snprintf(text,80,"Version %d.%d.%d - Release date %s\n",OZEDIT_VERSION,OZEDIT_SUBVERSION,OZEDIT_PATCH,OZEDIT_RELEASE_DATE);
#endif
    about_label = gtk_label_new(text);
    gtk_table_attach_defaults(GTK_TABLE(about_table),about_label,0,1,1,2);	
    gtk_widget_show(about_label);

    gtk_widget_show(about_table);
    gtk_widget_show(about_dialog);
    gtk_dialog_run(GTK_DIALOG(about_dialog));
    gtk_widget_destroy(about_dialog);
}

/* == OzEDIT_ErrorDialog() ========================================================= */
void OzEDIT_ErrorDialog(char *v_message,void *v_args) {
    GtkWidget *error_dialog;
    error_dialog = gtk_message_dialog_new(NULL,GTK_DIALOG_DESTROY_WITH_PARENT,GTK_MESSAGE_ERROR,GTK_BUTTONS_CLOSE,v_message,v_args);
    gtk_dialog_run (GTK_DIALOG(error_dialog));
    gtk_widget_destroy(error_dialog);
    return;
}

/* == OzEDIT_InfoDialog() ========================================================= */
void OzEDIT_InfoDialog(char *v_message,void *v_args) {
    GtkWidget *info_dialog;
    info_dialog = gtk_message_dialog_new(NULL,GTK_DIALOG_DESTROY_WITH_PARENT,GTK_MESSAGE_INFO,GTK_BUTTONS_CLOSE,v_message,v_args);
    gtk_dialog_run (GTK_DIALOG(info_dialog));
    gtk_widget_destroy(info_dialog);
    return;
}

/* == OzEDIT_TextEntry() ==================================================== */
gchar *OzEDIT_TextEntry(gchar *title,gchar *def_entry) {
	GtkWidget *text_dialog,*text_entry;
	gchar *text;
	
	text = g_malloc0(64);
	text_dialog = gtk_dialog_new_with_buttons(title,NULL,GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,GTK_STOCK_OK,GTK_RESPONSE_ACCEPT,NULL);
	gtk_window_set_default_size(GTK_WINDOW(text_dialog),200,50);
	
	text_entry = gtk_entry_new_with_max_length(64);
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(text_dialog)->vbox), text_entry);
	gtk_widget_show(text_entry);
	
	if(def_entry != NULL) gtk_entry_set_text(GTK_ENTRY(text_entry),def_entry);
	
	gtk_dialog_run(GTK_DIALOG(text_dialog));
	
	g_stpcpy(text,gtk_entry_get_text(GTK_ENTRY(text_entry)));
	
	/* Chiudi la Finestra */ 
	gtk_widget_destroy(text_dialog);
	
	return (gchar *)text;
}

/* == OzEDIT_FindDialog() ==================================================== */

GtkWidget *find_check_case,*find_check_findall,*find_check_replace,*find_entry_find,*find_entry_replace;

void OzEDIT_CBFindButton(GtkWidget *widget,gpointer *data) {
#ifdef DEBUG
    g_print("Find %s and Replace with %s\n",gtk_entry_get_text(GTK_ENTRY(find_entry_find)),gtk_entry_get_text(GTK_ENTRY(find_entry_replace)));
#endif    
    /* Find And Replace - OBJECT - TEXT TO FIND - TEXT TO REPLACE OR NULL - OPTIONS */
    OzEDIT_FindAndReplace(OzEDIT_ReturnObjectFromFrameID(topclass.current_frame_id),gtk_entry_get_text(GTK_ENTRY(find_entry_find)),gtk_entry_get_text(GTK_ENTRY(find_entry_replace)),gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(find_check_case)),gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(find_check_findall)),gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(find_check_replace)));    
}

void OzEDIT_CBFindCheckReplace(GtkWidget *widget,gpointer *data) {
    if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(find_check_replace))) {
	gtk_entry_set_editable(GTK_ENTRY(find_entry_replace),TRUE);
    } else {
	gtk_entry_set_editable(GTK_ENTRY(find_entry_replace),FALSE);
    }
}

void OzEDIT_FindDialog() {
	GtkWidget *find_dialog,*find_table,*find_label,*find_button,*find_label_replace;
	gchar *text;
	
	text = g_malloc0(64);
	find_dialog = gtk_dialog_new_with_buttons("Find",NULL,GTK_DIALOG_DESTROY_WITH_PARENT,GTK_STOCK_OK,GTK_RESPONSE_ACCEPT,NULL);
	gtk_window_set_default_size(GTK_WINDOW(find_dialog),200,50);
	
	find_table = gtk_table_new(3,3,FALSE);
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(find_dialog)->vbox),find_table);
	
	find_label = gtk_label_new("Text to find:");
	gtk_table_attach_defaults(GTK_TABLE(find_table),find_label,0,1,0,1);	
	gtk_widget_show(find_label);
	
	find_entry_find = gtk_entry_new_with_max_length(64);
	gtk_table_attach_defaults(GTK_TABLE(find_table),find_entry_find,1,3,0,1);	
	gtk_widget_show(find_entry_find);

	find_label_replace = gtk_label_new("Replace with:");
	gtk_table_attach_defaults(GTK_TABLE(find_table),find_label_replace,0,1,1,2);	
	gtk_widget_show(find_label_replace);
	
	find_entry_replace = gtk_entry_new_with_max_length(64);
	gtk_table_attach_defaults(GTK_TABLE(find_table),find_entry_replace,1,3,1,2);	
	gtk_entry_set_editable(GTK_ENTRY(find_entry_replace),FALSE);
	gtk_widget_show(find_entry_replace);

	find_check_replace = gtk_check_button_new_with_label("Replace");
	gtk_table_attach_defaults(GTK_TABLE(find_table),find_check_replace,0,1,2,3);	
	g_signal_connect(G_OBJECT(find_check_replace),"toggled",G_CALLBACK(OzEDIT_CBFindCheckReplace),NULL);
	gtk_widget_show(find_check_replace);

	find_check_case = gtk_check_button_new_with_label("Case sensitive");
	gtk_table_attach_defaults(GTK_TABLE(find_table),find_check_case,1,2,2,3);	
	gtk_widget_show(find_check_case);

	find_check_findall = gtk_check_button_new_with_label("Find/Replace All");
	gtk_table_attach_defaults(GTK_TABLE(find_table),find_check_findall,2,3,2,3);	
	gtk_widget_show(find_check_findall);

	gtk_widget_show(find_table);
		
	find_button = gtk_button_new_with_label("Find !");
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(find_dialog)->action_area),find_button);
	g_signal_connect(G_OBJECT(find_button),"clicked",G_CALLBACK(OzEDIT_CBFindButton),NULL);
	gtk_widget_show(find_button);	
	
	gtk_widget_grab_default(find_button); 
	
	gtk_dialog_run(GTK_DIALOG(find_dialog));	
	/* Chiudi la Finestra */ 
	gtk_widget_destroy(find_dialog);
}

/* == OzEDIT_ObjectProperties() ==================================================== */
#warning "OzEDIT_ObjectProperties() - UNFINISHED"
void OzEDIT_ObjectProperties(struct _OzEDIT_Object *object) {
	GtkWidget *prop_dialog,*prop_table,*prop_label_name,*prop_label_filename,*prop_entry_name,*prop_entry_filename;
	GtkWidget *prop_label_type,*prop_combo_type;
	GList *prop_combolist_type=NULL;

	prop_dialog = gtk_dialog_new_with_buttons("Object Properties",NULL,GTK_DIALOG_DESTROY_WITH_PARENT,GTK_STOCK_OK,GTK_RESPONSE_ACCEPT,NULL);
	gtk_window_set_default_size(GTK_WINDOW(prop_dialog),200,50);
	
	prop_table = gtk_table_new(3,3,FALSE);
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(prop_dialog)->vbox),prop_table);
	
	prop_label_name = gtk_label_new("Object name:");
	gtk_table_attach_defaults(GTK_TABLE(prop_table),prop_label_name,0,1,0,1);	
	gtk_widget_show(prop_label_name);
	
	prop_entry_name = gtk_entry_new_with_max_length(64);
	gtk_entry_set_text(GTK_ENTRY(prop_entry_name),object->name);
	gtk_table_attach_defaults(GTK_TABLE(prop_table),prop_entry_name,1,3,0,1);	
	gtk_widget_show(prop_entry_name);

	prop_label_filename = gtk_label_new("Associated Filename:");
	gtk_table_attach_defaults(GTK_TABLE(prop_table),prop_label_filename,0,1,1,2);	
	gtk_widget_show(prop_label_filename);
	
	prop_entry_filename = gtk_entry_new_with_max_length(64);
	gtk_table_attach_defaults(GTK_TABLE(prop_table),prop_entry_filename,1,3,1,2);
	gtk_entry_set_text(GTK_ENTRY(prop_entry_filename),object->filename);
	gtk_entry_set_editable(GTK_ENTRY(prop_entry_filename),FALSE);
	gtk_widget_show(prop_entry_filename);

	prop_label_type = gtk_label_new("Object Type:");
	gtk_table_attach_defaults(GTK_TABLE(prop_table),prop_label_type,0,1,2,3);	
	gtk_widget_show(prop_label_type);
	
	prop_combo_type = gtk_combo_new();
	prop_combolist_type = g_list_append(prop_combolist_type,"None");
	prop_combolist_type = g_list_append(prop_combolist_type,"C Header");
	prop_combolist_type = g_list_append(prop_combolist_type,"C Source");
	prop_combolist_type = g_list_append(prop_combolist_type,"Java Source");
	prop_combolist_type = g_list_append(prop_combolist_type,"Perl");
	prop_combolist_type = g_list_append(prop_combolist_type,"HTML");
	prop_combolist_type = g_list_append(prop_combolist_type,"Unknown");
	gtk_combo_set_popdown_strings(GTK_COMBO(prop_combo_type),prop_combolist_type);
	switch(object->type) {
		case OBJECT_TYPE_NONE:
				gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(prop_combo_type)->entry),"None");
				break;
		case OBJECT_TYPE_CHEADER:
				gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(prop_combo_type)->entry),"C Header");
				break;
		case OBJECT_TYPE_CSOURCE:
				gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(prop_combo_type)->entry),"C Source");
				break;
		case OBJECT_TYPE_JAVASOURCE:
				gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(prop_combo_type)->entry),"Java Source");
				break;
		case OBJECT_TYPE_PERL:
				gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(prop_combo_type)->entry),"Perl");
				break;
		case OBJECT_TYPE_HTML:
				gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(prop_combo_type)->entry),"HTML");
				break;
		default:
				gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(prop_combo_type)->entry),"Unknown");
				break;
	}
	gtk_table_attach_defaults(GTK_TABLE(prop_table),prop_combo_type,1,3,2,3);
	gtk_widget_show(prop_combo_type);

	gtk_widget_show(prop_table);
		
	gtk_dialog_run(GTK_DIALOG(prop_dialog));	
	/* Verifica i dati */
	
	/* Chiudi la Finestra */ 
	gtk_widget_destroy(prop_dialog);
}


/* == OzEDIT_BookmarkProperties() ==================================================== */
#warning "OzEDIT_BookmarkProperties() - UNFINISHED"
void OzEDIT_BookmarkProperties(struct _OzEDIT_Object *object,struct _OzEDIT_Bookmark *bookmark) {
	GtkWidget *prop_dialog,*prop_table,*prop_label_name,*prop_entry_name;

	prop_dialog = gtk_dialog_new_with_buttons("Bookmark Properties",NULL,GTK_DIALOG_DESTROY_WITH_PARENT,GTK_STOCK_OK,GTK_RESPONSE_ACCEPT,NULL);
	gtk_window_set_default_size(GTK_WINDOW(prop_dialog),200,50);
	
	prop_table = gtk_table_new(3,3,FALSE);
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(prop_dialog)->vbox),prop_table);
	
	prop_label_name = gtk_label_new("Bookmark name:");
	gtk_table_attach_defaults(GTK_TABLE(prop_table),prop_label_name,0,1,0,1);	
	gtk_widget_show(prop_label_name);
	
	prop_entry_name = gtk_entry_new_with_max_length(64);
	gtk_entry_set_text(GTK_ENTRY(prop_entry_name),bookmark->bk_name);
	gtk_table_attach_defaults(GTK_TABLE(prop_table),prop_entry_name,1,3,0,1);	
	gtk_widget_show(prop_entry_name);

	gtk_widget_show(prop_table);
		
	gtk_dialog_run(GTK_DIALOG(prop_dialog));	
	/* Verifica i dati - Cambiato qualcosa ? */
	if(g_ascii_strcasecmp(gtk_entry_get_text(GTK_ENTRY(prop_entry_name)),bookmark->bk_name) != 0) {
	    if(OzEDIT_AreYouSureDialog("Do you really want to change %s properties ?",bookmark->bk_name) == GTK_RESPONSE_YES) {
		g_stpcpy(bookmark->bk_name,gtk_entry_get_text(GTK_ENTRY(prop_entry_name)));
	    }	
	}
	/* Chiudi la Finestra */ 
	gtk_widget_destroy(prop_dialog);
}
