/*
===============================================================================
=== Released under GPL (GNU Public License) ==== No Any Warranty ==============
===============================================================================

Recent Files

*/

#include "../include/common.h"
#include "../include/recent.h" 

GtkTreeIter recent_selected_iter; /* Contiene l'ITER dell'Oggetto Selezionato */
GtkTreeStore *recenttreestore;

static gint OzEDIT_CBRecentBrowserPopupMenu(GtkWidget *widget, GdkEvent *event,GtkWidget *recenttree)
{
	GtkWidget *menu;
	GdkEventButton *event_button;
	GtkTreeSelection *tree_selection;
	GtkTreeModel *tree_model;
	gint *indices,c;
	gchar *value;
    
	g_return_val_if_fail(widget != NULL, FALSE);
	g_return_val_if_fail(event != NULL, FALSE);
	
	tree_model = gtk_tree_view_get_model(GTK_TREE_VIEW(recenttree));
	tree_selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(recenttree));
	if(!gtk_tree_selection_get_selected(tree_selection,NULL,&recent_selected_iter)) {
	    return;
	}

	gtk_tree_model_get(tree_model,&recent_selected_iter,1,&value,-1);

#ifdef DEBUG
	g_print("DEBUG: Selected %s \n",value);
#endif
	/* Doppio click con SINISTRO ! */
	if(event->type == GDK_2BUTTON_PRESS)	{
	    event_button = (GdkEventButton *)event;
	    if (event_button->button == 1)   {
		OzEDIT_CreateNewObject(value);
	    }
	}
	return FALSE;
}

void OzEDIT_RecentUpdateList() {
    GdkPixbuf *pixbuf_file;
    struct _OzEDIT_RecentFile *temprecent;
    guint i;
    
    gtk_tree_store_clear(GTK_TREE_STORE(recenttreestore));
    
#ifndef _NOGDKPIXBUF
    pixbuf_file = gdk_pixbuf_new_from_xpm_data((gchar **)file_xpm);
#endif
    for(i=0;i<g_list_length(topclass.recentfiles);i++) {
	temprecent = g_list_nth_data(topclass.recentfiles,i);
    	gtk_tree_store_append(GTK_TREE_STORE(recenttreestore),&temprecent->treeiter,NULL);
	gtk_tree_store_set(GTK_TREE_STORE(recenttreestore),&temprecent->treeiter,0,pixbuf_file,1,temprecent->name,-1);
    }
}


void OzEDIT_RecentAddFile(gchar *name) {
    struct _OzEDIT_RecentFile *temprecent;
    /* verifica che la lista sia piu piccola di quanto specificato e libera elementi in esubero */
    while(g_list_length(topclass.recentfiles) > (OzEDIT_Config.lenght_recent_files_list+1)) {
	temprecent = g_list_nth_data(topclass.recentfiles,0);
	topclass.recentfiles = g_list_remove(topclass.recentfiles,temprecent);
	g_free(temprecent);
    }
    /* Aggiungi alla lista dei file recenti */
    temprecent = g_malloc0(sizeof(struct _OzEDIT_RecentFile));
    g_strlcpy(temprecent->name,name,256);
    topclass.recentfiles = g_list_append(topclass.recentfiles,temprecent);
}

/************ OzEDIT_recentFiles() - The MAIN Procedure ******************************************************************/
GtkWidget *OzEDIT_RecentFiles() {
	GtkWidget *v_scrollable,*recenttree;	
	GtkTreeViewColumn *column;
	GtkCellRenderer *renderer;

	/* Scrollable per la LISTA TREE */
	v_scrollable =  gtk_scrolled_window_new(NULL,NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(v_scrollable),GTK_POLICY_AUTOMATIC,GTK_POLICY_AUTOMATIC);
	gtk_widget_set_size_request(GTK_WIDGET(v_scrollable), -1, 380);
	gtk_container_set_border_width(GTK_CONTAINER(v_scrollable),1);
	gtk_widget_show(v_scrollable);

	/* Tree List Widget */
	recenttreestore = gtk_tree_store_new(2,GDK_TYPE_PIXBUF,G_TYPE_STRING);
	recenttree = gtk_tree_view_new_with_model(GTK_TREE_MODEL(recenttreestore));
	g_object_unref(G_OBJECT(recenttreestore));
	gtk_tree_view_set_rules_hint(GTK_TREE_VIEW(recenttree), TRUE);
	gtk_tree_selection_set_mode(gtk_tree_view_get_selection(GTK_TREE_VIEW(recenttree)),GTK_SELECTION_SINGLE);
	
	column = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(column,"Recent Files");
	
	renderer = gtk_cell_renderer_pixbuf_new();
	gtk_tree_view_column_pack_start(column,renderer,FALSE);
	gtk_tree_view_column_add_attribute(column,renderer,"pixbuf",0);

	renderer = gtk_cell_renderer_text_new();
	gtk_tree_view_column_pack_start(column,renderer,FALSE);
	gtk_tree_view_append_column(GTK_TREE_VIEW(recenttree),GTK_TREE_VIEW_COLUMN(column));
	gtk_tree_view_column_add_attribute(column,renderer,"text",1);
	
        g_signal_connect(G_OBJECT(recenttree),"button_press_event",G_CALLBACK(OzEDIT_CBRecentBrowserPopupMenu),recenttree); 
	
	gtk_widget_set_size_request(recenttree,200,0);
	gtk_container_add(GTK_CONTAINER(v_scrollable),recenttree);

	gtk_widget_show(recenttree);

	return (GtkWidget *)v_scrollable;
}
