/*
===============================================================================
=== Released under GPL (GNU Public License) ==== No Any Warranty ==============
===============================================================================

Undo & Redo

*/

#include "../include/common.h"
#include "../include/undoredo.h" 

#warning "Undo & Redo - BUGGED AND UNFINISHED"

struct _OzEDIT_UndoRedo {
    gchar *data;
    guint type;
    GtkTextIter start,end;
};

#define UNDOREDO_TYPE_DELETERANGE 1
#define UNDOREDO_TYPE_INSERTTEXT 2

void OzEDIT_DoUndo(struct _OzEDIT_Object *object) {
    struct _OzEDIT_UndoRedo *undoitem;
#ifdef DEBUG
    g_print("DEBUG: DoUndo for %s\n",object->name);
#endif
    /* preleva ultimo evento UNDO ... */
    undoitem = g_list_nth_data(object->listundo,g_list_length(object->listundo)-1);
    /* ...e rimuovilo dalla lista ! */
    object->listundo = g_list_remove(object->listundo,undoitem); 
    /* Esegui l'undo */
    switch(undoitem->type) {
	case UNDOREDO_TYPE_DELETERANGE: 
#ifdef DEBUG
	        g_print("DEBUG: DoUndo DELETE RANGE %s\n",undoitem->data);
#endif
		gtk_text_buffer_insert(object->text_buffer,&undoitem->start,undoitem->data,strlen(undoitem->data));
	    break;
	case UNDOREDO_TYPE_INSERTTEXT:
#ifdef DEBUG
	        g_print("DEBUG: DoUndo INSERT TEXT %s\n",undoitem->data);
#endif
		 gtk_text_buffer_delete(object->text_buffer,&undoitem->start,&undoitem->end);
	    break;
	default:
	    break;
    }
    /* Aggiungilo alla lista REDO ! */
    OzEDIT_TrimList(object->listredo);
    object->listredo = g_list_append(object->listredo,(struct _OzEDIT_UndoRedo *)undoitem);
}

void OzEDIT_DoRedo(struct _OzEDIT_Object *object) {
    struct _OzEDIT_UndoRedo *redoitem;
#ifdef DEBUG
    g_print("DEBUG: DoRedo for %s\n",object->name);
#endif

}


void OzEDIT_CBUndoRedoDeleteRange(GtkTextBuffer *textbuffer,GtkTextIter *start,GtkTextIter *end,struct _OzEDIT_Object *object) {
    struct _OzEDIT_UndoRedo *undoredo;
#ifdef DEBUG
    g_print("DEBUG: CBUndoRedoDeleteRange for %s -> %s\n",object->name,gtk_text_iter_get_text(start,end));
#endif
    OzEDIT_TrimList(object->listundo);
    undoredo = g_malloc0(sizeof(struct _OzEDIT_UndoRedo));    
    undoredo->type = UNDOREDO_TYPE_DELETERANGE;
    memcpy(&undoredo->start,gtk_text_iter_copy(start),sizeof(GtkTextIter));
    memcpy(&undoredo->end,gtk_text_iter_copy(end),sizeof(GtkTextIter));
    undoredo->data = g_malloc0(strlen(gtk_text_iter_get_text(start,end)));
    g_strlcpy(undoredo->data,gtk_text_iter_get_text(start,end),strlen(gtk_text_iter_get_text(start,end)));
    object->listundo = g_list_append(object->listundo,(struct _OzEDIT_UndoRedo *)undoredo);
}

void OzEDIT_CBUndoRedoInsertText(GtkTextBuffer *textbuffer,GtkTextIter *start,gchar *arg2,gint arg3,struct _OzEDIT_Object *object) {
    struct _OzEDIT_UndoRedo *undoredo;
#ifdef DEBUG
    g_print("DEBUG: CBUndoRedoInsertText for %s -> %s\n",object->name,arg2);
#endif
    OzEDIT_TrimList(object->listundo);
    undoredo = g_malloc0(sizeof(struct _OzEDIT_UndoRedo));    
    undoredo->type = UNDOREDO_TYPE_INSERTTEXT;
    memcpy(&undoredo->start,gtk_text_iter_copy(start),sizeof(GtkTextIter));
    memcpy(&undoredo->end,gtk_text_iter_copy(start),sizeof(GtkTextIter));
    gtk_text_iter_forward_chars(&undoredo->end,strlen(arg2));
    undoredo->data = g_malloc0(strlen(arg2));
    g_strlcpy(undoredo->data,arg2,strlen(arg2));
    object->listundo = g_list_append(object->listundo,(struct _OzEDIT_UndoRedo *)undoredo);
}

/* Inzializza Undo & Redo */
void OzEDIT_UndoRedoInit(struct _OzEDIT_Object *object) {
    object->listundo=NULL;
    object->listredo=NULL;
    g_signal_connect(G_OBJECT(object->text_buffer),"delete-range",G_CALLBACK(OzEDIT_CBUndoRedoDeleteRange),object);
    g_signal_connect(G_OBJECT(object->text_buffer),"insert-text",G_CALLBACK(OzEDIT_CBUndoRedoInsertText),object);
}


void OzEDIT_TrimList(GList *list) {
    struct _OzEDIT_UndoRedo *undoredo;
    while(g_list_length(list) > (OzEDIT_Config.lenght_undoredo+1)) {
#ifdef DEBUG
        g_print("DEBUG: TrimList %d (Limit %d)\n",g_list_length(list),OzEDIT_Config.lenght_undoredo+1);
#endif    
	undoredo = g_list_nth_data(list,0);
	list = g_list_remove(list,undoredo);
	g_free(undoredo->data);
	g_free(undoredo);
    }
}
